﻿;10.06.21 - fixed save binary, save settings, implement max width
; 22.02.2023 zoom preview
; 22.07.2023 new color modes

UsePNGImageEncoder()
Global *m
Global fs=0 ;filesize
Global sw=1 ;spritewidth
Global disp=0
Global v$="SpriteGrabber 2d"
Global zoom=1
Global Dim revbyte.a(255)
Global Dim nibs.a(255)
Global tosave$=""
Global openfolder$=GetCurrentDirectory()
Global noerror; error flag convert string
Global maxw=256
Global ontop=0
Global ww=512;320+180;window w
Global jumpto.l=-1; jump value for mouse menu
Global cmo=0      ; color mode

Enumeration ; gadgets
  #ca
  #sv
  #sh
  #opt_inv
  #opt_rev
  #opt_grid
  #opt_multicol
  #ofs
  #ns
  #opt_z
EndEnumeration

Enumeration ; menu items
  #file_quit
  #file_saveb
  #file_savei
  #file_open
  #z1
  #z2
  #z4
  #z8
  #view_grid
  #view_inverse
  #view_reverse
  #view_multicol
  #view_ontop
  #view_zoom
  #mnu2_jumphere
  
  #cmode_bin
  #cmode_atari
  #cmode_bk
  #cmode_sc
EndEnumeration

Global Dim atacol.l(15)

Procedure cleanmem()
  If *m
    FreeMemory(*m)
  EndIf
  
EndProcedure

Procedure loadfile(f$)
  cleanmem()
  fs=FileSize(f$)
  *m=AllocateMemory(fs+16)
  If *m=0
    MessageRequester("Memory","Unable to allocate memory!")
    End
  Else
    If ReadFile(0,f$)
      If ReadData(0,*m,fs)
        CloseFile(0)
        tosave$=GetFilePart(f$)
        openfolder$=GetPathPart(f$)
        SetGadgetAttribute(#sv,#PB_ScrollBar_Maximum ,Int(fs/sw))
      Else
        MessageRequester("File Read Error","Unable to read:"+f$)
        End
        
      EndIf
    Else
      MessageRequester("File Error","Unable to open:"+f$)
      End
    EndIf
  EndIf
EndProcedure

Procedure drawmem()
  If *m
    If StartDrawing(ImageOutput(0))
      ;      Box(0,0,600,ww,0)
      For y=0 To ww
        For x=0 To 599
          Box(x,y,1,1,$ffff00*((x!y)&1))
        Next x
        Next y
      ;
      x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
      y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
      xx = Int(x/zoom)
      yy = Int(y/zoom)
      bs=Int(x/8/zoom)*Int(ww/zoom)+y*sw/zoom
      p=disp+GetGadgetState(#ofs)
      StatusBarText(0, 0, "Disp="+Str(p)+",width="+Str(sw)+",x="+Str(xx)+",y="+Str(yy)+",size="+Str(bs), #PB_StatusBar_BorderLess)
      x0=0
      y0=0
      ;zoomer
      zb=zoom
      If zb=8
        zb=zb-1
      EndIf
      ;inverse option
      inv=0
      If GetGadgetState(#opt_inv)
        inv=255
      EndIf

      xend=75
      ;setup colors
      Select cmo
        Case 1:;atari
          atacol(0)=0
          atacol(1)=RGB(179,101,79);RGB(166,149,50)
          atacol(2)=RGB(132,188,53);RGB(118,205,167)
          atacol(3)=RGB(12,81,94);RGB(60,69,175)
        Case 2:;BK-0010
          atacol(0)=0  
          atacol(1)=RGB(0,0,255) 
          atacol(2)=RGB(0,255,0)
          atacol(3)=RGB(255,0,0)
          xend=192
        Case 3:;Sam |Coupe mode 4
          atacol(00)=$0;0
          atacol(01)=$490000;1
          atacol(02)=$49    ;2
          atacol(03)=$490049;3
          atacol(04)=$4900  ;4
          atacol(05)=$494900;5
          atacol(06)=$4949  ;6
          atacol(07)=$494949;7
          atacol(08)=$242424;8
          atacol(09)=$6D2424;9
          atacol(10)=$24246D;10
          atacol(11)=$6D246D;11
          atacol(12)=$246D24;12
          atacol(13)=$6D6D24;13
          atacol(14)=$246D6D;14
          atacol(15)=$6D6D6D;15
          xend=80;300
      EndSelect
      
      ;xend=75
      While x0<xend
        For x=1 To sw
          If p<=fs And p>=0
            a.a=PeekA(*m+p)!inv
          Else
            a.a=0
          EndIf
          ;reverse byte option
          If GetGadgetState(#opt_rev)
            a=revbyte(a)
          EndIf
          ;nibble swap
          If GetGadgetState(#ns)
            a=nibs(a)
          EndIf
          
          Select cmo
            Case 0:;binary
              b.a=128
              For i=0 To 7
                If a&b
                  pc=$ffffff
                Else
                  pc=0
                EndIf
;                 If p>=fs
;                   pc=$ff0000
;                 EndIf
                If zoom=8
                Box((x0*8+x*8+i-8)*zoom,y0,zb+1,zb+1,0)
                EndIf
                Box((x0*8+x*8+i-8)*zoom,y0,zb,zb,pc)
;                 If pc=$ff0000
;                   Box((x0*8+x*8+i-8)*zoom,y0,zb+1,zb+1,pc)
;                 Else
;                   Box((x0*8+x*8+i-8)*zoom,y0,zb,zb,pc)
;                 EndIf
                b=b>>1
              Next i
            Case 1: ;gr.15
              For i=3 To 0 Step -1
                pc=atacol(a&3)
;                 If p>=fs
;                   pc=$ff0000
;                 EndIf
                Box(((x0+x)*8+i*2-8)*zoom,y0,zoom*2,zoom,pc)
                a>>2
              Next i
            Case 2: ;BK-0010
              For i=0 To 3
                pc=atacol(a&3)
                If p>=fs
                  pc=$ff0000
                EndIf
                Box(((x0+x)*4+i-4)*zoom,y0,zoom,zoom,pc)
                a>>2
              Next i
            Case 3: ;Sam Coupe
              Box( ((x0+x)*2+i-2)*zoom,y0,zoom,zoom,atacol((a&$F0)>>4) )
              Box( ((x0+x)*2+i-1)*zoom,y0,zoom,zoom,atacol(a&$0F) )
            Default:
              Debug Str(cmo)+" not implemented"
              End
          EndSelect
          p=p+1
If p>=fs
                  Break 2
                EndIf
        Next x
        y0=y0+zoom
        If y0>=ww
          y0=0
          x0=x0+sw
          
          If GetGadgetState(#opt_multicol)=0
            Break
          EndIf
          
        EndIf
      Wend
      StopDrawing()
    Else
      MessageRequester("image","It happens")
    EndIf
    
    x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
    y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
    
    If zoom=1 And GetGadgetState(#opt_z)
      If x>=0 And y>=0
        GrabImage(0,2,x+2,y+2,8,8)
        ResizeImage(2,64*2,64*2,#PB_Image_Raw)
      EndIf
    EndIf
    
    If StartDrawing(CanvasOutput(0))
      DrawImage(ImageID(0),0,0)
      If zoom=1 And GetGadgetState(#opt_z)
        x=WindowMouseX(0)
        y=WindowMouseY(0)
        If x>=0 And y>=0
          DrawImage(ImageID(2),x+1,y+1)
          FreeImage(2)
        EndIf
      EndIf
      
      If GetGadgetState(#opt_grid)
        For i=0 To 600 Step 8
          grc=$ff00
          If i&56
            grc=$7f00
          EndIf
          LineXY(i,0,i,ww,grc)
          LineXY(0,i,600,i,grc)
        Next i
      EndIf
      StopDrawing()
    Else
      MessageRequester("Canvas","It happens")
    EndIf
    
    SetWindowTitle(0,v$+",x"+Str(zoom))
  EndIf
EndProcedure

Procedure.l str2num(s$)
  noerror=1
  s$=UCase(s$)
  basen=10
  based$="0123456789"
  If Mid(s$,1,1)="$"
    basen=16
    based$="0123456789ABCDEF"
    s$=Mid(s$,2)
  EndIf
  r.l=0
  For i=1 To Len(s$)
    p=FindString(based$,Mid(s$,i,1))
    If p=0
      noerror=0
      r=0
      Break
    Else
      r=r*basen+p-1
    EndIf
  Next i
  ProcedureReturn r
EndProcedure

Procedure savebin()
  I$ = InputRequester("size", "Enter size(hex/dec)", "0000")
  If i$
    ;calc value
    ss=str2num(i$)
    If noerror=0
      MessageRequester("wrong input","can't convert:"+i$)
    Else
      p=disp+GetGadgetState(#ofs)
      If p+ss>fs
        MessageRequester("Save binary file","Too big value!")
      Else
        Pattern$ = "Binary file (*.bin)|*.bin"
        File$ = SaveFileRequester("Please choose file to save", openfolder$, Pattern$, 0)
        If File$
          ex$=".bin"
          For i=Len (File$) To 1 Step -1
            If Mid(File$,i,1)="."
              ex$=""
              Break
            EndIf
            If Mid(File$,i,1)="\"
              Break
            EndIf
          Next i
          file$=File$+ex$
;           If LCase(Mid(File$,Len(File$)-3))<>".bin"
;             file$=File$+".bin"
;           EndIf
;;          inv=0
          If GetGadgetState(#opt_inv)
            inv=255
          Else
            inv=0
          EndIf
          If CreateFile(0,File$)
            p=disp+GetGadgetState(#ofs)
            For i=1 To ss
              If p<0
                a.a=0
              Else
                a.a=PeekA(*m+p)!inv
                If GetGadgetState(#opt_rev)
                  a=revbyte(a)
                EndIf
              EndIf
              WriteAsciiCharacter(0,a)
              p=p+1
            Next i
            CloseFile(0)
          Else
            MessageRequester("Save binary file","Cannot save"+#CRLF$+File$)
          EndIf
        EndIf
      EndIf;p>fs
    EndIf  ;if noerror=0
  EndIf    ;if i$
  
EndProcedure

Procedure BindVScrollDatas()
  sw=GetGadgetState(#sh)
  disp=GetGadgetState(#sv)*sw
  SetGadgetAttribute(#sv,#PB_ScrollBar_Maximum ,Int(fs/sw))
  SetGadgetAttribute(#ofs,#PB_Spin_Minimum,-sw)
  SetGadgetAttribute(#ofs,#PB_Spin_Maximum,sw)
  drawmem()
EndProcedure

Procedure resetitems(item)
  For i=#cmode_bin To #cmode_sc
    If i=item 
      menust=1
    Else
      menust=0
    EndIf
    SetMenuItemState(0,i,menust)
  Next i
EndProcedure

;image for drawing
CreateImage(0,600,ww)

If OpenWindow(0, 0, 0, 620, ww+90, v$, #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#ca, 0, 0, 600, ww)
  ScrollBarGadget(#sv, 600, 0, 20, ww, 0, 32, 1,#PB_ScrollBar_Vertical)
  ScrollBarGadget(#sh, 0, ww, 600, 20, 1, 255, 1)
  
  BindGadgetEvent(#sv, @BindvScrollDatas())
  BindGadgetEvent(#sh, @BindVScrollDatas())
  
  CheckBoxGadget(#opt_inv,0,ww+20,30,20,"i"):GadgetToolTip(#opt_inv, "inverse byte")
  CheckBoxGadget(#opt_rev,40,ww+20,40,20,"R"):GadgetToolTip(#opt_rev, "reverse byte")
  CheckBoxGadget(#opt_grid,80,ww+20,40,20,"g"):GadgetToolTip(#opt_grid, "grid")
  CheckBoxGadget(#opt_multicol,120,ww+20,40,20,"m"):GadgetToolTip(#opt_multicol, "Multi column")
  CheckBoxGadget(#ns,160,ww+20,40,20,"n"):GadgetToolTip(#ns, "Nibble Swap")
  CheckBoxGadget(#opt_z,200,ww+20,40,20,"z"):GadgetToolTip(#opt_z, "zoomed preview")
  
  SpinGadget(#ofs,240,ww+20,80,20,-1,1):GadgetToolTip(#ofs, "offset")
  
  EnableGadgetDrop(#ca,#PB_Drop_Files,#PB_Drag_Copy)
  StartDrawing(CanvasOutput(#ca))
  Box(0,0,600,ww,0)
  StopDrawing()
  
  If CreateStatusBar(0, WindowID(0))
    AddStatusBarField(600)
  EndIf
  
  If CreatePopupMenu(2)
    MenuItem(#mnu2_jumphere, "jump here")
  EndIf
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open..."+Chr(9)+"Ctrl+O")
    MenuItem(#file_saveb, "Save binary...")
    MenuItem(#file_savei, "Save image...")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    
    MenuTitle("View")
    OpenSubMenu("Zoom")
    MenuItem( #view_zoom, "zoom preview"+Chr(9)+"Ctrl+Z")
    MenuItem( #z1, "zoom x1"+Chr(9)+"Ctrl+1")
    MenuItem( #z2, "zoom x2"+Chr(9)+"Ctrl+2")
    MenuItem( #z4, "zoom x4"+Chr(9)+"Ctrl+4")
    MenuItem( #z8, "zoom x8"+Chr(9)+"Ctrl+8")
    CloseSubMenu()
    ;--color mode
    OpenSubMenu("Color mode")
    MenuItem( #cmode_bin, "Binary")
    MenuItem( #cmode_atari, "Atari GR.15")
    MenuItem( #cmode_bk, "BK-0010")
    MenuItem( #cmode_sc, "Sam Coupe mode 4")
    SetMenuItemState(0,#cmode_bin,1)
    CloseSubMenu()
    
    MenuItem(#view_grid, "Grid"+Chr(9)+"Ctrl+G")
    MenuItem(#view_inverse, "Inverse"+Chr(9)+"Ctrl+I")
    MenuItem(#view_multicol, "Multi columns"+Chr(9)+"Ctrl+M")
    MenuItem(#view_reverse, "Reverse byte"+Chr(9)+"Ctrl+R")
    MenuItem(#view_ontop, "Stay on top"+Chr(9)+"Ctrl+T")
    CloseSubMenu()
    
    MenuItem(#z1,"x1")
    MenuItem(#z2,"x2")
    MenuItem(#z4,"x4")
    MenuItem(#z8,"x8")
  EndIf
  ;keyboard
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_G, #view_grid)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_I, #view_inverse)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_M, #view_multicol)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_R, #view_reverse)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_T, #view_ontop)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Z, #view_zoom)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_1, #z1)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_2, #z2)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_4, #z4)
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_8, #z8)
  
  ;read settings
  If OpenPreferences("sg2.ini")
    PreferenceGroup("Options")
    zoom=ReadPreferenceInteger("zoom", 1)
    If zoom<>1 And zoom<>2 And zoom<>4 And zoom<>8
      zoom=1
      MessageRequester("Wrong settings","Zoom must be 1,2,4,8.Fixed")
    EndIf
    SetGadgetState(#opt_multicol,ReadPreferenceInteger("Multi", 0))
    SetMenuItemState(0,#view_multicol,GetGadgetState(#opt_multicol))
    SetGadgetState(#opt_grid,ReadPreferenceInteger("Grid", 0))
    SetGadgetState(#opt_inv,ReadPreferenceInteger("Inverse", 0))
    SetGadgetState(#opt_rev,ReadPreferenceInteger("Reverse", 0))
    ontop=ReadPreferenceInteger("ontop", 0)
    SetMenuItemState(0,#view_ontop,ontop)
    If ontop
      StickyWindow(0,1)
    EndIf
    maxw=ReadPreferenceInteger("maxwidth", 256)
    If maxw>256 Or maxw<=0
      maxw=75
      MessageRequester("Wrong settings","Bad maxwidth.Fixed to 75")
    EndIf

    SetGadgetAttribute(#sh,#PB_ScrollBar_Maximum,maxw)
    ClosePreferences()
  EndIf
  ;reverse byte *nibbleswap
  For i=0 To 255
    revbyte(i)=Val( "%"+ReverseString( RSet( Bin(i),8,"0" ) ) )
    nibs(i)=((i&$0F)<<4)|((i&$F0)>>4)
  Next i
  ;commandline
  If CountProgramParameters()
    loadfile( ProgramParameter(0) )
    drawmem()
  EndIf
  
  Repeat
    Event = WaitWindowEvent()
    
    If GetAsyncKeyState_(#VK_ESCAPE) & $8000
      Break
    EndIf
    ;keys
    If GetAsyncKeyState_(#VK_RIGHT) & $8000
      d=GetGadgetState(#sh)
      If d<maxw
        SetGadgetState(#sh,d+1)
        BindVScrollDatas()
        ;drawmem()
      EndIf
    EndIf
    
    If GetAsyncKeyState_(#VK_LEFT) & $8000
      d=GetGadgetState(#sh)
      If d>1;GetGadgetAttribute(#sh,#PB_ScrollBar_Maximum)>1
        SetGadgetState(#sh,d-1)
        BindVScrollDatas()
        ;drawmem()
      EndIf
    EndIf
    
    If GetAsyncKeyState_(#VK_UP) & $8000
      d=GetGadgetState(#sv)
      If d
        SetGadgetState(#sv,d-1)
        BindVScrollDatas()
      EndIf
    EndIf
    
    If GetAsyncKeyState_(#VK_DOWN) & $8000
      d=GetGadgetState(#sv)
      If d<>GetGadgetAttribute(#sv,#PB_ScrollBar_Maximum)
        SetGadgetState(#sv,d+1)
        BindVScrollDatas()
      EndIf
    EndIf
    
    Select Event
        
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        Files$ = StringField(Files$, 1, Chr(10))
        loadfile(Files$)
        drawmem()
        ;-- mouse wheel
      Case #WM_MOUSEWHEEL
        tt.w=(EventwParam()>>16)&$FFFF
        If tt<0
          d=GetGadgetState(#sv)
          SetGadgetState(#sv,d+16)
          BindVScrollDatas()
        ElseIf tt>0
          d=GetGadgetState(#sv)
          ;If d<>GetGadgetAttribute(#sv,#PB_ScrollBar_Maximum)
          If d>16
            SetGadgetState(#sv,d-16)
            BindVScrollDatas()
          EndIf
          ;EndIf
        EndIf
        
      Case #PB_Event_Gadget
        ;--gadgets events
        Select EventGadget()
          Case #opt_z
            If GetGadgetState(#opt_z)=0
              drawmem()
            EndIf
          Case #ns
            drawmem()
          Case #ca
            ;-- jump here
            If EventType() = #PB_EventType_RightClick; And zoom=1
              x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
              y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
              xx = Int(x/zoom)
              yy = Int(y/zoom)
              jumpto=(Int(x/8/zoom)*Int(ww/zoom)+y*sw/zoom)/sw+GetGadgetState(#sv)
              DisplayPopupMenu(2,WindowID(0))
            EndIf
            
            If EventType() = #PB_EventType_MouseMove; And zoom=1
              x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
              y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
              xx = Int(x/zoom)
              yy = Int(y/zoom)
              bs=Int(x/8/zoom)*Int(ww/zoom)+y*sw/zoom
              p=disp+GetGadgetState(#ofs)
              ;--zoom
              StatusBarText(0, 0, "Disp:"+Str(p)+",width="+Str(sw)+",x="+Str(xx)+",y="+Str(yy)+",size:"+Str(bs), #PB_StatusBar_BorderLess)
              If GetGadgetState(#opt_z) And zoom=1
                drawmem()
              EndIf
            EndIf
          Case #ofs
            SetGadgetText(#ofs, Str(GetGadgetState(#ofs)))
            drawmem()
            SetActiveGadget(#opt_inv)
          Case #opt_multicol
            SetMenuItemState(0,#view_multicol,GetGadgetState(#opt_multicol))
            drawmem()
          Case #opt_grid
            drawmem()
            SetMenuItemState(0,#view_grid,GetGadgetState(#opt_grid))
          Case #opt_rev
            SetMenuItemState(0,#view_reverse,GetGadgetState(#opt_rev))
            drawmem()
          Case #opt_inv
            drawmem()
            SetMenuItemState(0,#view_inverse,GetGadgetState(#opt_inv))
        EndSelect
        ;--menu events
      Case #PB_Event_Menu
        Select EventMenu()
          Case #cmode_bin
            cmo=0
            resetitems(#cmode_bin)
            drawmem()
          Case #cmode_atari
            cmo=1
            resetitems(#cmode_atari)
            drawmem()
          Case #cmode_bk
            cmo=2
            resetitems(#cmode_bk)
            drawmem()
          Case #cmode_sc
            cmo=3
            resetitems(#cmode_sc)
            drawmem()

          Case #mnu2_jumphere
            If jumpto<>-1
              SetGadgetState(#sv,jumpto)
              BindVScrollDatas()
              jumpto=-1
            EndIf
          Case #view_zoom
            t=GetGadgetState(#opt_z)
            SetMenuItemState(0,#view_ontop,1-ontop)
            SetGadgetState(#opt_z,1-t)
            drawmem()
          Case #view_ontop
            ontop=1-ontop
            SetMenuItemState(0,#view_ontop,ontop)
            StickyWindow(0,ontop)
          Case #view_grid
            t=GetMenuItemState(0,#view_grid)
            SetMenuItemState(0,#view_grid,1-t)
            SetGadgetState(#opt_grid,1-t)
            drawmem()
          Case #view_inverse
            t=GetMenuItemState(0,#view_inverse)
            SetMenuItemState(0,#view_inverse,1-t)
            SetGadgetState(#opt_inv,1-t)
            drawmem()
          Case #view_multicol
            t=GetMenuItemState(0,#view_multicol)
            SetMenuItemState(0,#view_multicol,1-t)
            SetGadgetState(#opt_multicol,1-t)
            drawmem()
          Case #view_reverse
            t=GetMenuItemState(0,#view_reverse)
            SetMenuItemState(0,#view_reverse,1-t)
            SetGadgetState(#opt_rev,1-t)
            drawmem()

          Case #z1 : zoom=1:drawmem()
          Case #z2 : zoom=2:drawmem()
          Case #z4 : zoom=4:drawmem()
          Case #z8 : zoom=8:drawmem()
          Case #file_quit:
            Break
          Case #file_open:
            Pattern$ = "All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", openfolder$, Pattern$, 0)
            If File$
              openfolder$=GetPathPart(File$)
              loadfile(File$)
              drawmem()
            EndIf
          Case #file_saveb:
            savebin()
          Case #file_savei:
            Pattern$ = "Portable Network Graphics(*.png)|*.png|Bitmap (*.bmp)|*.bmp"
            File$ = SaveFileRequester("Please choose file to save", openfolder$+tosave$, Pattern$, 0)
            SelectedFilePattern()
            If File$
              Select SelectedFilePattern()
                Case 0:
                  If LCase(Mid(File$,Len(File$)-3))<>".png"
                    file$=File$+".png"
                  EndIf
                  If Not SaveImage(0,File$,#PB_ImagePlugin_PNG)
                    MessageRequester("Save Image Error","Error saving"+#CRLF$+File$)
                  EndIf
                Case 1:
                  If LCase(Mid(File$,Len(File$)-3))<>".bmp"
                    file$=File$+".bmp"
                  EndIf
                  If Not SaveImage(0,File$)
                    MessageRequester("Save Image Error","Error saving"+#CRLF$+File$)
                  EndIf
              EndSelect
            EndIf
        EndSelect
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

;save settings
If CreatePreferences("sg2.ini")
  PreferenceGroup("Options")
  WritePreferenceInteger("Zoom", zoom)
  WritePreferenceInteger("Multi", GetGadgetState(#opt_multicol))
  WritePreferenceInteger("Grid", GetGadgetState(#opt_grid))
  WritePreferenceInteger("Inverse", GetGadgetState(#opt_inv))
  WritePreferenceInteger("Reverse", GetGadgetState(#opt_rev))
  WritePreferenceInteger("maxwidth", maxw)
  WritePreferenceInteger("ontop", ontop)
  ClosePreferences()
EndIf

FreeImage(0)
cleanmem()

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 507
; FirstLine = 481
; Folding = --
; EnableXP
; UseIcon = sg2.ico
; Executable = sg2d.exe
; Debugger = IDE